package com.ibm.xml.internal;

import com.ibm.xml.framework.StringPool;

class CMLeaf extends CMNode {
   private int fElementIndex;
   private int fPosition = -1;

   CMLeaf(int var1, int var2, int var3) throws CMException {
      super(var1);
      if (((CMNode)this).type() != 0) {
         throw new CMException(155);
      } else {
         this.fElementIndex = var2;
         this.fPosition = var3;
      }
   }

   CMLeaf(int var1, int var2) throws CMException {
      super(var1);
      if (((CMNode)this).type() != 0) {
         throw new CMException(155);
      } else {
         this.fElementIndex = var2;
      }
   }

   final int getElemIndex() {
      return this.fElementIndex;
   }

   final int getPosition() {
      return this.fPosition;
   }

   final void setPosition(int var1) {
      this.fPosition = var1;
   }

   boolean isNullable() throws CMException {
      return this.fPosition == -1;
   }

   String toString(StringPool var1) {
      StringBuffer var2 = new StringBuffer(var1.toString(this.fElementIndex));
      if (this.fPosition >= 0) {
         var2.append(" (Pos:" + (new Integer(this.fPosition)).toString() + ")");
      }

      return var2.toString();
   }

   protected void calcFirstPos(CMStateSet var1) throws CMException {
      if (this.fPosition == -1) {
         var1.zeroBits();
      } else {
         var1.setBit(this.fPosition);
      }
   }

   protected void calcLastPos(CMStateSet var1) throws CMException {
      if (this.fPosition == -1) {
         var1.zeroBits();
      } else {
         var1.setBit(this.fPosition);
      }
   }
}
