package com.ibm.xml.internal;

abstract class CMNode {
   private int fType;
   private CMStateSet fFirstPos;
   private CMStateSet fFollowPos;
   private CMStateSet fLastPos;
   private int fMaxStates = -1;

   CMNode(int var1) throws CMException {
      this.fType = var1;
   }

   abstract boolean isNullable() throws CMException;

   final int type() {
      return this.fType;
   }

   final CMStateSet firstPos() throws CMException {
      if (this.fFirstPos == null) {
         this.fFirstPos = new CMStateSet(this.fMaxStates);
         this.calcFirstPos(this.fFirstPos);
      }

      return this.fFirstPos;
   }

   final CMStateSet lastPos() throws CMException {
      if (this.fLastPos == null) {
         this.fLastPos = new CMStateSet(this.fMaxStates);
         this.calcLastPos(this.fLastPos);
      }

      return this.fLastPos;
   }

   final void setFollowPos(CMStateSet var1) {
      this.fFollowPos = var1;
   }

   final void setMaxStates(int var1) {
      this.fMaxStates = var1;
   }

   protected abstract void calcFirstPos(CMStateSet var1) throws CMException;

   protected abstract void calcLastPos(CMStateSet var1) throws CMException;
}
