package com.ibm.xml.internal;

import com.ibm.xml.framework.Catalog;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class DefaultCatalog implements Catalog {
   private Hashtable publicMap = new Hashtable();
   private Hashtable systemMap = new Hashtable();

   public void addPublicMapping(String var1, String var2) {
      this.publicMap.put(var1, var2);
   }

   public void removePublicMapping(System var1) {
      this.publicMap.remove(var1);
   }

   public Enumeration getPublicMappingKeys() {
      return this.publicMap.keys();
   }

   public String getPublicMapping(String var1) {
      return (String)this.publicMap.get(var1);
   }

   public void addSystemMapping(String var1, String var2) {
      this.systemMap.put(var1, var2);
   }

   public void removeSystemMapping(String var1) {
      this.systemMap.remove(var1);
   }

   public Enumeration getSystemMappingKeys() {
      return this.systemMap.keys();
   }

   public String getSystemMapping(String var1) {
      return (String)this.systemMap.get(var1);
   }

   public InputSource resolveEntity(String var1, String var2) throws SAXException, IOException {
      if (var1 != null) {
         String var3 = this.getPublicMapping(var1);
         if (var3 != null) {
            return new InputSource(var3);
         }
      }

      if (var2 != null) {
         String var4 = this.getSystemMapping(var2);
         if (var4 == null) {
            var4 = var2;
         }

         return new InputSource(var4);
      } else {
         return null;
      }
   }

   public void loadCatalog(InputSource var1) throws Exception {
      throw new Exception("loadCatalog not implemented");
   }
}
