package com.ibm.xml.internal;

import com.ibm.xml.framework.ParserState;
import com.ibm.xml.framework.StringPool;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;
import java.util.StringTokenizer;
import org.xml.sax.InputSource;

public class TXCatalog extends DefaultCatalog {
   private ParserState state;

   public TXCatalog(ParserState var1) {
      this.state = var1;
   }

   public void loadCatalog(InputSource var1) throws Exception {
      Object var2 = var1.getCharacterStream();
      if (var2 == null) {
         InputStream var3 = var1.getByteStream();
         if (var3 != null) {
            var2 = new InputStreamReader(var3);
         } else {
            StringPool var4 = this.state.getStringPool();
            int var5 = var4.addString(var1.getSystemId());
            int var6 = this.state.getEntityHandler().expandSystemId(var5);
            if (var6 != var5) {
               var4.releaseString(var5);
            }

            String var7 = var4.orphanString(var6);
            var2 = new InputStreamReader((new URL(var7)).openStream());
         }
      }

      if (var2 != null) {
         BufferedReader var8 = new BufferedReader((Reader)var2);

         String var9;
         while((var9 = var8.readLine()) != null) {
            StringTokenizer var10 = new StringTokenizer(var9, "\t");
            String var11 = var10.nextToken();
            if (var11 != null) {
               String var12 = var10.nextToken();
               if (var12 != null) {
                  ((DefaultCatalog)this).addPublicMapping(var11, var12);
               }
            }
         }

         var8.close();
      }

   }

   protected ParserState getParserState() {
      return this.state;
   }
}
